# /submissions/{submissionId}/upload

Retrieve uploaded file from a submission

# OpenAPI definition

```json
{
  "openapi": "3.0.0",
  "info": {
    "title": "Formstack API v2025.0",
    "version": "0.0.4"
  },
  "servers": [
    {
      "url": "https://www.formstack.com/api/v2025",
      "description": "Production server"
    },
    {
      "url": "https://staging-formstack.com/api/v2025",
      "description": "Staging server"
    },
    {
      "url": "https://dev-formstack.com/api/v2025",
      "description": "Development server"
    }
  ],
  "paths": {
    "/submissions/{submissionId}/upload": {
      "get": {
        "tags": [
          "Submissions",
          "Classic"
        ],
        "description": "Retrieve uploaded file from a submission",
        "operationId": "getSubmissionUpload",
        "parameters": [
          {
            "name": "submissionId",
            "in": "path",
            "description": "The unique identifier of the submission containing the upload",
            "required": true,
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "fieldId",
            "in": "query",
            "description": "The unique identifier of the field containing the uploaded file",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/GetSubmissionUploadApiDto/properties/fieldId"
            }
          },
          {
            "name": "index",
            "in": "query",
            "description": "The index of the file when multiple files are uploaded to the same field (zero-based)",
            "required": false,
            "schema": {
              "$ref": "#/components/schemas/GetSubmissionUploadApiDto/properties/index"
            }
          },
          {
            "name": "X-FS-Encryption-Password",
            "in": "header",
            "description": "Required when form has encryption enabled. The encryption password used to decrypt file upload data",
            "required": false,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/octet-stream": {
                "schema": {
                  "type": "string",
                  "format": "binary"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized - Encryption password required or invalid"
          },
          "403": {
            "description": "Forbidden"
          },
          "404": {
            "description": "Not Found"
          },
          "500": {
            "description": "Internal Server Error"
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "GetSubmissionUploadApiDto": {
        "title": "Get Submission Upload",
        "description": "Request parameters for retrieving uploaded files from submissions",
        "properties": {
          "fieldId": {
            "description": "The unique identifier of the field containing the uploaded file",
            "type": "integer",
            "nullable": false
          },
          "index": {
            "description": "The index of the file when multiple files are uploaded to the same field (zero-based)",
            "type": "integer",
            "nullable": true
          }
        },
        "type": "object"
      }
    }
  },
  "tags": [
    {
      "name": "Submissions",
      "description": "Submissions are the entries collected by your forms. Use these endpoints to create a submission, list submissions across all forms or for a specific form, count submissions, retrieve a single submission's data, edit or delete a submission, download uploaded files, and generate presigned URLs for direct file uploads. Results support pagination, date ranges, and field-level search."
    },
    {
      "name": "Classic",
      "description": "Classic"
    }
  ]
}
```